diff --git a/zebra/zebra_dplane.c b/zebra/zebra_dplane.c
index a88b0a38da81..7f993442a624 100644
--- a/zebra/zebra_dplane.c
+++ b/zebra/zebra_dplane.c
@@ -3752,7 +3752,9 @@ void zebra_dplane_shutdown(void)
 
 	zdplane_info.dg_run = false;
 
-	THREAD_OFF(zdplane_info.dg_t_update);
+	if (zdplane_info.dg_t_update)
+		thread_cancel_async(zdplane_info.dg_t_update->master,
+				    &zdplane_info.dg_t_update, NULL);
 
 	frr_pthread_stop(zdplane_info.dg_pthread, NULL);
 
